<template>
  <AtomAutocomplete
    :label="label"
    :name="name"
    :search-fn="searchRegionsFn"
    :value="selectedValue"
    :required="required"
    @result-selected="onSelectRegion"
  />
</template>

<script setup>
  const { $request } = useNuxtApp()

  const props = defineProps({
    label: {
      type: String,
      required: true
    },
    name: {
      type: String,
      required: true
    },
    value: {
      type: String,
      default: ''
    },
    required: {
      type: Boolean,
      default: false
    }
  })

  const emit = defineEmits(['regionSelected'])

  const regions = ref([])
  const selectedValue = ref(props.value)

  watch(
    () => props.value,
    value => {
      selectedValue.value = value
    }
  )

  async function searchRegionsFn(search) {
    if (search.length < 3) return new Map()

    const params = new URLSearchParams({
      nom: search,
      limit: '3'
    })

    const res = await $request(`https://geo.api.gouv.fr/regions?${params}`)

    if (res.status === 200) {
      regions.value = res.data
      return new Map(regions.value.map(({ nom, code }) => [code, nom]))
    }
    throw new Error(res.data.errors[0].message)
  }

  function onSelectRegion(code) {
    const region = regions.value.find(a => a.code === code)
    if (!region) return
    selectedValue.value = region.nom
    emit('regionSelected', region.nom)
  }
</script>
